<h1 id="combobox">Combobox</h1>
<p>Combobox is a combination of a text box and a pop-up listbox containing options that help the user set the value of the text box.</p>
<p>Combobox conforms to the ARIA 1.0 pattern of <a href="https://www.w3.org/WAI/ARIA/apg/patterns/combobox/">W3C's WAI-ARIA authoring practices</a>.</p>
<h2 id="set-up">Set up</h2>
<p>First import the styles into your main SASS file, replacing <code>&lt;path-to-node_modules&gt;</code> with the path to the <em>node_modules</em> directory relative to the file:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/components/combobox/combobox';
</code></pre>
<p>Alternatively <em>ace.scss</em> includes all ACE component SASS files, so if using multiple ACE components it can be imported instead:</p>
<pre><code class="language-scss">@import '&lt;path-to-node_modules&gt;/@potato/ace/ace';
</code></pre>
<p>A CSS file is also provided for convenience and is located at <code>&lt;path-to-node_modules&gt;/@potato/ace/components/combobox/ace-combobox.css</code>.</p>
<p>Then import the class into your JavaScript entry point:</p>
<pre><code class="language-js">import '&lt;path-to-node_modules&gt;/@potato/ace/components/combobox/combobox';
</code></pre>
<p>For convenience the ES6 class is exported as <code>Combobox</code> and the attribute names used by the class are exported as properties of <code>ATTRS</code>.</p>
<p>After the event <code>DOMContentLoaded</code> is fired on <code>document</code> an instance of Combobox is instantiated within each <code>&lt;ace-combobox&gt;</code> element and an ID <code>ace-combobox-&lt;n&gt;</code> is added for any instance without one, where <code>&lt;n&gt;</code> is a unique integer. Once instantiation is complete a custom event <code>ace-combobox-ready</code> is dispatched to <code>window</code>. See the <strong>Custom events</strong> section below for more details.</p>
<p>Combobox must have a descendant input box and will use a <code>&lt;input&gt;</code> with attribute <code>ace-combobox-input</code>. If no descendant has this attribute then the first descendant <code>&lt;input&gt;</code> will be used and given the attribute. It is strongly recommended that this <code>&lt;input&gt;</code> is given an accessible label using either <code>aria-label</code> or <code>aria-labelledby</code>. Similarly, Combobox must have a descendant list and will use a <code>&lt;ul&gt;</code> with attribute <code>ace-combobox-list</code>. If no descendant has this attribute then the first descendant <code>&lt;ul&gt;</code> will be used and given the attribute. It is strongly recommended that the <code>&lt;ul&gt;</code> is given an accessible label using <code>aria-label</code>, describing its options.</p>
<p>The list can be empty upon instantiation and options can be dynamically added to, or removed from, it later as long as custom event <code>ace-combobox-update-options</code> is dispatched to the Combobox instance afterwards.</p>
<h2 id="usage">Usage</h2>
<p>Comboboxes come in three main types depending on auto-complete behaviour; no auto-completion, list auto-completion, and inline and list auto-completion. Futhermore, each of these types can have manual or automatic selection, where no option or the first option is selected respectively when the listbox appears or its options are updated. Manual selection is the default behaviour and users can select the first or last option in the listbox once it appears by pressing <kbd>↑</kbd> or <kbd>↓</kbd> respectively. Automatic selection can be activated by adding an attribute <code>ace-combobox-autoselect</code> to the Combobox.</p>
<p>The following features apply to all Combobox types:</p>
<ul>
<li><kbd>↓</kbd> selects the next option unless no option or the last option is selected in which cases it selects the first option.</li>
<li><kbd>↑</kbd> selects the previous option unless no option or the first option is selected in which cases it selects the last option.</li>
<li><kbd>Esc</kbd> hides the listbox without changing the value of the input textbox.</li>
<li><kbd>Enter</kbd> chooses the selected option changing the input textbox value to match that of the chosen option and dispatching a custom event <code>ace-combobox-option-chosen</code>. This is also achieved by clicking on an option. An attribute <code>ace-combobox-no-input-update</code> can be added to the Combobox to dispatch the event without updating the input textbox.</li>
<li>When the Combobox loses focus the listbox is automatically hidden. If the listbox had a selected option before it was hidden that option is automatically chosen.</li>
</ul>
<h3 id="simple-combobox">Simple Combobox</h3>
<p>The Combobox, instantiated by default, has no auto-complete behaviour and therefore contains a list of options that remain unchanged regardless of user input. This type is typically used to suggest recently entered strings, for example recently searched for values. The listbox of a simple Combobox is automatically shown when the Combobox gains focus.</p>
<h3 id="list-auto-completion-combobox">List auto-completion Combobox</h3>
<p>In this type of Combobox the listbox options are filtered to only show options with text that starts with the characters typed by the user. To instantiate a Combobox with list auto-completion add <code>aria-autocomplete=&quot;list&quot;</code> to the <code>&lt;input&gt;</code> element.</p>
<h3 id="inline-and-list-auto-completion-combobox">Inline and list auto-completion Combobox</h3>
<p>A Combobox with input and list auto-completion behaves the same as that with list auto-completion and additionally changes the input value to match the text of the selected option. For the automatic selection variant the input textbox value is auto-completed as the user types, with the portion of the string not typed by the user highlighted as selected text so it can be overwritten. To instantiate a Combobox with inline and list auto-completion add <code>aria-autocomplete=&quot;both&quot;</code> to the <code>&lt;input&gt;</code> element.</p>
<h2 id="styles">Styles</h2>
<p>The following SASS is applied to Combobox. The SASS variables use <code>!default</code> so can also be easily overridden by users. SASS variables used that are not defined here are defined in <em>&lt;path-to-node_modules&gt;/@potato/ace/common/constants.scss</em>, which also contains styles used for making sure the entire listbox is always visible within a window.</p>
<pre><code class="language-scss">@import '../../common/constants';


// VARIABLES
$ace-combobox-list-bg-color: #fff !default;
$ace-combobox-list-height: auto !default;
$ace-combobox-selected-option-bg-color: $ace-color-selected !default;
$ace-combobox-selected-option-text-color: #fff !default;


// STYLES
ace-combobox {
	display: inline-block;
	position: relative;
}

[ace-combobox-input] {
	width: 100%;
}

[ace-combobox-list] {
	background: $ace-combobox-list-bg-color;
	height: $ace-combobox-list-height;
	left: 0;
	list-style: none;
	overflow-y: auto;
	position: absolute;
	text-align: left;
	top: 100%;
	user-select: none;
	white-space: nowrap;
	width: 100%;
	z-index: $ace-combobox-list-z-index;

	&amp;:not([ace-combobox-list-visible]) {
		display: none;
	}

	[aria-selected=&quot;true&quot;] {
		background: $ace-combobox-selected-option-bg-color;
		color: $ace-combobox-selected-option-text-color;
	}

	&amp;[ace-u-float-above] {
		bottom: 100%;
		top: initial;
	}

	&amp;[ace-u-float-left] {
		left: initial;
		right: 0;
	}

	&amp;[ace-u-float-right] {
		left: 0;
		right: initial;
	}
}
</code></pre>
<h2 id="custom-events">Custom events</h2>
<p>Combobox uses the following custom events, the names of which are available in its exported <code>EVENTS</code> object, similar to <code>ATTRS</code>, so they may be imported into other modules.</p>
<h3 id="dispatched-events">Dispatched events</h3>
<p>The following events are dispatched to <code>window</code> by Combobox.</p>
<h4 id="ready">Ready</h4>
<p><code>ace-combobox-ready</code></p>
<p>This event is dispatched when Combobox finishes initialising. The event name is available as <code>EVENTS.OUT.READY</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Combobox [string]
}
</code></pre>
<h4 id="list-toggled">List toggled</h4>
<p><code>ace-combobox-list-toggled</code></p>
<p>This event is dispatched when the listbox is toggled. The event name is available as <code>EVENTS.OUT.LIST_TOGGLED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Combobox [string],
	'listVisibile': // Whether the listbox is visible or not [boolean]
}
</code></pre>
<h4 id="option-selected">Option selected</h4>
<p><code>ace-combobox-option-selected</code></p>
<p>This event is dispatched when a listbox option is selected. The event name is available as <code>EVENTS.OUT.OPTION_SELECTED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Combobox [string],
	'selectedOptionId': // ID of selected option [string]
}
</code></pre>
<h4 id="option-chosen">Option chosen</h4>
<p><code>ace-combobox-option-chosen</code></p>
<p>This event is dispatched when an option is chosen by the user, either by clicking on an option or by pressing <kbd>Enter</kbd> when the listbox has a selected option. The event name is available as <code>EVENTS.OUT.OPTION_CHOSEN</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Combobox [string],
	'chosenOptionId': // ID of chosen option [string]
}
</code></pre>
<h4 id="options-updated">Options updated</h4>
<p><code>ace-combobox-options-updated</code></p>
<p>This event is dispatched when Combobox has finished updating its options. The event name is available as <code>EVENTS.OUT.OPTIONS_UPDATED</code> and its <code>detail</code> property is composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of Combobox [string]
}
</code></pre>
<h3 id="listened-for-events">Listened for events</h3>
<p>Combobox listens for the following events that should be dispatched to <code>window</code>.</p>
<h4 id="hide-and-show-list">Hide and show list</h4>
<p><code>ace-combobox-hide-list</code> &amp; <code>ace-combobox-show-list</code></p>
<p>These events should be dispatched to hide &amp; show the listbox respectively. The event names are available as <code>EVENTS.IN.HIDE_LIST</code> &amp; <code>EVENTS.IN.SHOW_LIST</code> and their <code>detail</code> properties should be composed as follows:</p>
<pre><code class="language-js">'detail': {
  'id': // ID of target Combobox [string]
}
</code></pre>
<h4 id="select-option">Select option</h4>
<p><code>ace-combobox-select-option</code></p>
<p>This event should be dispatched to programatically select an option. The event name is available as <code>EVENTS.IN.SELECT_OPTION</code>, and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Combobox [string]
	'optionId': // ID of option to select [string]
}
</code></pre>
<h4 id="update-options">Update options</h4>
<p><code>ace-combobox-update-options</code></p>
<p>This event should be dispatched when options are added to or removed from the list and causes Combobox to initialise them and then dispatch the <code>ace-combobox-ready</code> event. The event name is available as <code>EVENTS.IN.UPDATE_OPTIONS</code>, and its <code>detail</code> property should be composed as follows:</p>
<pre><code class="language-js">'detail': {
	'id': // ID of target Combobox [string]
}
</code></pre>
<h2 id="examples">Examples</h2>
<p>Each example contains a live demo and the HTML code that produced it. The code shown may differ slightly to that rendered for the demo as some components may alter their HTML when they initialise.</p>
<h3 id="comboboxes-with-manual-selection">Comboboxes with manual selection</h3>
<p>These are the three types of Comboboxes, all with manual selection.</p>
<div class="example-block"><h4>No auto-complete</h4>
<span id="combobox-label-1">Choose an Avenger:</span>
<ace-combobox>
	<input aria-labelledby="combobox-label-1" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
<hr>
<h4>List auto-complete</h4>
<span id="combobox-label-2">Choose an Avenger:</span>
<ace-combobox id="ace-ac-list-combobox">
	<input aria-autocomplete="list" aria-labelledby="combobox-label-2" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
<hr>
<h4>Inline and list auto-complete</h4>
<span id="combobox-label-3">Choose an Avenger:</span>
<ace-combobox id="ace-ac-both-combobox">
	<input aria-autocomplete="both" aria-labelledby="combobox-label-3" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
</div>
<pre><code class="language-html">&lt;h4&gt;No auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-1&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox&gt;
	&lt;input aria-labelledby=&quot;combobox-label-1&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;

&lt;hr&gt;

&lt;h4&gt;List auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-2&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox id=&quot;ace-ac-list-combobox&quot;&gt;
	&lt;input aria-autocomplete=&quot;list&quot; aria-labelledby=&quot;combobox-label-2&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;

&lt;hr&gt;

&lt;h4&gt;Inline and list auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-3&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox id=&quot;ace-ac-both-combobox&quot;&gt;
	&lt;input aria-autocomplete=&quot;both&quot; aria-labelledby=&quot;combobox-label-3&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;
</code></pre>
<h3 id="comboboxes-with-automatic-selection">Comboboxes with automatic selection</h3>
<p>Same as previous example but with automatic selection enabled.</p>
<div class="example-block"><h4>No auto-complete</h4>
<span id="combobox-label-4">Choose an Avenger:</span>
<ace-combobox ace-combobox-autoselect id="ace-simple-autoselect-combobox">
	<input aria-labelledby="combobox-label-4" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
<hr>
<h4>List auto-complete</h4>
<span id="combobox-label-5">Choose an Avenger:</span>
<ace-combobox ace-combobox-autoselect id="ace-ac-list-autoselect-combobox">
	<input aria-autocomplete="list" aria-labelledby="combobox-label-5" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
<hr>
<h4>Inline and list auto-complete</h4>
<span id="combobox-label-6">Choose an Avenger:</span>
<ace-combobox ace-combobox-autoselect id="ace-ac-both-autoselect-combobox">
	<input aria-autocomplete="both" aria-labelledby="combobox-label-6" />
	<ul aria-label="Avengers">
		<li>Iron Man</li>
		<li>Nick Fury</li>
		<li>Hulk</li>
		<li>Thor</li>
		<li>Captain America</li>
		<li>Black Widow</li>
		<li>Scarlet Witch</li>
		<li>Ant-Man</li>
		<li>Black Panther</li>
		<li>Spider-man</li>
		<li>Doctor Strange</li>
		<li>Captain Marvel</li>
	</ul>
</ace-combobox>
</div>
<pre><code class="language-html">&lt;h4&gt;No auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-4&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox ace-combobox-autoselect id=&quot;ace-simple-autoselect-combobox&quot;&gt;
	&lt;input aria-labelledby=&quot;combobox-label-4&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;

&lt;hr&gt;

&lt;h4&gt;List auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-5&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox ace-combobox-autoselect id=&quot;ace-ac-list-autoselect-combobox&quot;&gt;
	&lt;input aria-autocomplete=&quot;list&quot; aria-labelledby=&quot;combobox-label-5&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;

&lt;hr&gt;

&lt;h4&gt;Inline and list auto-complete&lt;/h4&gt;
&lt;span id=&quot;combobox-label-6&quot;&gt;Choose an Avenger:&lt;/span&gt;

&lt;ace-combobox ace-combobox-autoselect id=&quot;ace-ac-both-autoselect-combobox&quot;&gt;
	&lt;input aria-autocomplete=&quot;both&quot; aria-labelledby=&quot;combobox-label-6&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot;&gt;
		&lt;li&gt;Iron Man&lt;/li&gt;
		&lt;li&gt;Nick Fury&lt;/li&gt;
		&lt;li&gt;Hulk&lt;/li&gt;
		&lt;li&gt;Thor&lt;/li&gt;
		&lt;li&gt;Captain America&lt;/li&gt;
		&lt;li&gt;Black Widow&lt;/li&gt;
		&lt;li&gt;Scarlet Witch&lt;/li&gt;
		&lt;li&gt;Ant-Man&lt;/li&gt;
		&lt;li&gt;Black Panther&lt;/li&gt;
		&lt;li&gt;Spider-man&lt;/li&gt;
		&lt;li&gt;Doctor Strange&lt;/li&gt;
		&lt;li&gt;Captain Marvel&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;
</code></pre>
<h3 id="combobox-controlled-using-custom-events">Combobox controlled using custom events</h3>
<p>The buttons in this example dispatch the <code>ace-tabs-set-prev-tab</code>, <code>ace-tabs-set-next-tab</code> and <code>ace-tabs-update-tabs</code> custom events on the Tabs.</p>
<p>The <strong>Add options</strong> button adds options to the initially empty Combobox then dispatches the <code>ace-combobox-update-options</code> custom event. The <strong>Show list</strong> and <strong>Hide list</strong> buttons dispatch the <code>ace-combobox-show-list</code> and <code>ace-combobox-hide-list</code> custom events to show and hide the listbox respectively. An option in the listbox can be selected by setting the option number in the <strong>Select option</strong> input and clicking <strong>Go</strong>, which dispatches the <code>ace-combobox-select-option</code> custom event. The JavaScript used by this example is shown below.</p>
<div class="example-block"><button id="add-options-btn">Add options</button>
<button id="show-list-btn">Show list</button>
<button id="hide-list-btn">Hide list</button>
<form id="select-option-form">
	<label>
		Select option:
		<input id="select-option-input" max="3" min="1" name="option-number" type="number" />
	</label>
	<button type="submit">Go</button>
</form>
<hr>
<span id="combobox-label-7">Custom events controlled Combobox:</span>
<ace-combobox id="ace-custom-events-combobox">
	<input aria-labelledby="combobox-label-7" />
	<ul aria-label="Custom events combobox options"></ul>
</ace-combobox>
</div>
<pre><code class="language-html">&lt;button id=&quot;add-options-btn&quot;&gt;Add options&lt;/button&gt;
&lt;button id=&quot;show-list-btn&quot;&gt;Show list&lt;/button&gt;
&lt;button id=&quot;hide-list-btn&quot;&gt;Hide list&lt;/button&gt;
&lt;form id=&quot;select-option-form&quot;&gt;
	&lt;label&gt;
		Select option:
		&lt;input id=&quot;select-option-input&quot; max=&quot;3&quot; min=&quot;1&quot; name=&quot;option-number&quot; type=&quot;number&quot; /&gt;
	&lt;/label&gt;
	&lt;button type=&quot;submit&quot;&gt;Go&lt;/button&gt;
&lt;/form&gt;
&lt;hr&gt;
&lt;span id=&quot;combobox-label-7&quot;&gt;Custom events controlled Combobox:&lt;/span&gt;
&lt;ace-combobox id=&quot;ace-custom-events-combobox&quot;&gt;
	&lt;input aria-labelledby=&quot;combobox-label-7&quot; /&gt;
	&lt;ul aria-label=&quot;Custom events combobox options&quot;&gt;&lt;/ul&gt;
&lt;/ace-combobox&gt;
</code></pre>
<pre><code class="language-js">import { ATTRS, EVENTS } from '/ace/components/combobox/combobox.js';

document.addEventListener('DOMContentLoaded', () =&gt; {
	const COMBOBOX_ID = 'ace-custom-events-combobox';
	const comboboxEl = document.getElementById(COMBOBOX_ID);
	const comboboxListEl = comboboxEl.querySelector(`[${ATTRS.LIST}]`);
	const selectOptionForm = document.getElementById('select-option-form');

	window.addEventListener('click', (e) =&gt; {
		switch (e.target.id) {
			case 'add-options-btn':
				for (let i = 0; i &lt; 3; i++) {
					const newOption = document.createElement('li');
					newOption.textContent = 'New Option';
					comboboxListEl.appendChild(newOption);
				}
				window.dispatchEvent(new CustomEvent(
						EVENTS.IN.UPDATE_OPTIONS,
						{'detail': {'id': COMBOBOX_ID}},
					));
				break;
			case 'show-list-btn':
				window.dispatchEvent(new CustomEvent(
						EVENTS.IN.SHOW_LIST,
						{'detail': {'id': COMBOBOX_ID}},
					));
				break;
			case 'hide-list-btn':
				window.dispatchEvent(new CustomEvent(
						EVENTS.IN.HIDE_LIST,
						{'detail': {'id': COMBOBOX_ID}},
					));
				break;
		}
	});

	selectOptionForm.addEventListener('submit', (e) =&gt; {
		e.preventDefault();
		const optionNumber = +new FormData(e.target).get('option-number');
		const option = comboboxEl.querySelectorAll('li')[optionNumber - 1];
		if (!option) {
			return;
		}
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.SELECT_OPTION,
			{
				'detail': {
					'id': COMBOBOX_ID,
					'optionId': option.id,
				}
			}
		));
	});
});
</code></pre>
<h3 id="search-combobox-with-dynamically-updated-options">Search Combobox with dynamically updated options</h3>
<p>This example demonstrates how Combobox can be used as a search box with results optained through an API call, where the user types a search string into the combobox then presses <kbd>Enter</kbd> to start the search. In the example the delay associated with a slow API call is simulated using a 3 second timeout. An element with attributes <code>role=&quot;status&quot;</code> and <code>aria-live=&quot;polite&quot;</code> is used to announce to the user via assistive technologies that the search is underway. After the timeout, results are added to the combobox's list, and are initialised by dispatching the <code>ace-combobox-update-options</code> custom event. The <code>role=&quot;status&quot;</code> element is finally updated to announce how many results were found. The JavaScript used by this example is shown below.</p>
<div class="example-block"><p aria-live="polite" role="status" id="combobox-status"></p>
<div>
	<label id="search-combobox-label">Search:</label>
	<ace-combobox id="ace-search-combobox" ace-combobox-no-input-update>
		<input aria-labelledby="search-combobox-label" />
		<ul aria-label="Search results"></ul>
	</ace-combobox>
</div>
<p aria-live="polite" role="status" id="chosen-search-result"></p>
<hr>
<p><button id="reset-example-btn">Reset example</button></p>
</div>
<pre><code class="language-html">&lt;p aria-live=&quot;polite&quot; role=&quot;status&quot; id=&quot;combobox-status&quot;&gt;&lt;/p&gt;

&lt;div&gt;
	&lt;label id=&quot;search-combobox-label&quot;&gt;Search:&lt;/label&gt;
	&lt;ace-combobox id=&quot;ace-search-combobox&quot; ace-combobox-no-input-update&gt;
		&lt;input aria-labelledby=&quot;search-combobox-label&quot; /&gt;
		&lt;ul aria-label=&quot;Search results&quot;&gt;&lt;/ul&gt;
	&lt;/ace-combobox&gt;
&lt;/div&gt;

&lt;p aria-live=&quot;polite&quot; role=&quot;status&quot; id=&quot;chosen-search-result&quot;&gt;&lt;/p&gt;

&lt;hr&gt;

&lt;button id=&quot;reset-example-btn&quot;&gt;Reset example&lt;/button&gt;
</code></pre>
<pre><code class="language-js">import { ATTRS, EVENTS } from '/ace/components/combobox/combobox.js';

export const FAKE_DELAY = 3000;
const COMBOBOX_ID = 'ace-search-combobox';

document.addEventListener('DOMContentLoaded', () =&gt; {
	let optionChosen, searching = false;
	const chosenResultEl = document.getElementById('chosen-search-result');
	const comboboxStatusEl = document.getElementById('combobox-status');
	const comboboxEl = document.getElementById(COMBOBOX_ID);
	const resetExampleBtn = document.getElementById('reset-example-btn');
	const comboboxInputEl = comboboxEl.querySelector(`[${ATTRS.INPUT}]`);
	const comboboxListEl = comboboxEl.querySelector(`[${ATTRS.LIST}]`);

	// Search when ENTER key pressed
	comboboxInputEl.addEventListener('keydown', async (e) =&gt; {
		const keyPressed = e.key || e.which || e.keyCode;
		if (!(keyPressed === 13 || keyPressed === 'Enter')) {
			return;
		}

		// If option selected when ENTER pressed prevent search
		if (optionChosen) {
			optionChosen = false;
			return;
		}

		if (searching || comboboxInputEl.value === '') {
			return;
		}
		searching = true;
		// Update status element to inform user there will be a delay
		comboboxStatusEl.textContent = 'Searching...';
		comboboxStatusEl.setAttribute('aria-busy', 'true');
		comboboxListEl.innerHTML = '';

		// Simulate an API reponse delay
		const results = await new Promise(resolve =&gt; setTimeout(() =&gt; {
			const data = [];
			for (let i = 1; i &lt; 6; i++) {
				data.push({ id: `result-${i}`, text: `Result ${i}` });
			}
			resolve(data);
		}, FAKE_DELAY));

		// Add results to DOM
		comboboxStatusEl.setAttribute('aria-busy', 'false');
		comboboxStatusEl.textContent = `${results.length} result${results.length === 1 ? '' : 's'} found`;
		comboboxListEl.innerHTML = '';
		results.forEach((result) =&gt; {
			const resultOption = document.createElement('li');
			resultOption.textContent = result.text;
			resultOption.id = result.id;
			comboboxListEl.appendChild(resultOption);
		});
		// Update combobox options
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.UPDATE_OPTIONS,
			{'detail': {'id': COMBOBOX_ID}},
		));
		searching = false;
	});

	// Show list when clicking on input if list has options
	comboboxInputEl.addEventListener('click', () =&gt; {
		if (comboboxListEl.childNodes.length === 0) {
			return;
		}
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.SHOW_LIST,
			{'detail': {'id': COMBOBOX_ID}},
		));
	});

	// Show results list when options intialised
	window.addEventListener(EVENTS.OUT.OPTIONS_UPDATED, (e) =&gt; {
		const detail = e['detail'];
		if (!detail || !detail['id'] || detail['id'] !== COMBOBOX_ID) {
			return;
		}
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.SHOW_LIST,
			{'detail': {'id': COMBOBOX_ID}},
		));
	});

	// Listen for chosen options
	window.addEventListener(EVENTS.OUT.OPTION_CHOSEN, (e) =&gt; {
		const detail = e['detail'];
		if (!detail || !detail['id'] || detail['id'] !== COMBOBOX_ID) {
			return;
		}
		optionChosen = true;
		chosenResultEl.textContent = `Option with ID '${detail['chosenOptionId']}' chosen.`;

		// Hide list
		window.dispatchEvent(new CustomEvent(
			EVENTS.IN.HIDE_LIST,
			{'detail': {'id': COMBOBOX_ID}},
		));
	});

	// Show list when clicking on input if list has options
	resetExampleBtn.addEventListener('click', () =&gt; {
		chosenResultEl.textContent = '';
		comboboxStatusEl.textContent = '';
		comboboxInputEl.value = '';
		comboboxListEl.innerHTML = '';
	});
});
</code></pre>
<h3 id="styled-combobox">Styled Combobox</h3>
<p>An example of how Combobox can be styled, with the applied CSS shown below.</p>
<div class="example-block"><label id="styled-combobox-label" class="styled-combobox-label">Choose an Avenger:</label>
<ace-combobox ace-combobox-autoselect class="styled-combobox">
	<input aria-autocomplete="list" aria-labelledby="styled-combobox-label" class="styled-combobox__input" />
	<ul aria-label="Avengers" class="styled-combobox__list">
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Iron Man
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Nick Fury
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Hulk
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Thor
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Captain America
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Black Widow
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Scarlet Witch
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Ant-Man
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Black Panther
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Spider-man
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Doctor Strange
		</li>
		<li class="styled-combobox__option">
			<img alt="Potato logo" class="styled-combobox__img" src="/img/logo.svg">
			Captain Marvel
		</li>
	</ul>
</ace-combobox>
</div>
<pre><code class="language-html">&lt;label id=&quot;styled-combobox-label&quot; class=&quot;styled-combobox-label&quot;&gt;Choose an Avenger:&lt;/label&gt;

&lt;ace-combobox ace-combobox-autoselect class=&quot;styled-combobox&quot;&gt;
	&lt;input aria-autocomplete=&quot;list&quot; aria-labelledby=&quot;styled-combobox-label&quot; class=&quot;styled-combobox__input&quot; /&gt;
	&lt;ul aria-label=&quot;Avengers&quot; class=&quot;styled-combobox__list&quot;&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Iron Man
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Nick Fury
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Hulk
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Thor
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Captain America
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Black Widow
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Scarlet Witch
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Ant-Man
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Black Panther
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Spider-man
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Doctor Strange
		&lt;/li&gt;
		&lt;li class=&quot;styled-combobox__option&quot;&gt;
			&lt;img alt=&quot;Potato logo&quot; class=&quot;styled-combobox__img&quot; src=&quot;/img/logo.svg&quot;&gt;
			Captain Marvel
		&lt;/li&gt;
	&lt;/ul&gt;
&lt;/ace-combobox&gt;
</code></pre>
<pre><code class="language-scss">.styled-combobox {
	&amp;-label,
	&amp;__input,
	&amp;__option,
	&amp;__status {
		font-family: 'Roboto', sans-serif;
		font-size: 14px;
	}

	&amp;__input,
	&amp;__list {
		border: 1px solid #837b8b;
		border-radius: 4px;
		width: 300px;

		&amp;:focus {
			outline-color: #41354d;
		}
	}

	&amp;__input,
	&amp;__option {
		padding: 10px 16px;
	}

	&amp;__list {
		max-height: 225px;
	}

	&amp;__option {
		align-items: center;
		display: flex;

		&amp;[aria-selected=&quot;true&quot;] {
			background: #41354d;
		}
	}

	&amp;__img {
		height: 2em;
		margin-right: 10px;
	}
}
</code></pre>
